/*
 *       ͻ
 *              Chi Programmer's Editor, Borland C++ 3.1       
 *                     
 *           Copyright (C) 1990,1991,1993                      
 *           Author: Fook H. Eng, 201 West Hilliard Avenue     
 *                   Monterey Park, CA 91754, 818 572-9220     
 *                                                             
 *       ͼ
 */
#include    <stdio.h>
#include    <string.h>
#include    "vartypes.h"
#include    "memory.h"
#include    "utils.h"
#include    "keys.h"
#include    "blocks.h"
#include    "cache.h"
#include    "initial.h"
#include    "windows.h"

int  in_cache(pLineDesc p)
{
    int     i;

    for (i = 0; i < MAXCACHEBLK; i++)
        if (p == cache[i].qld) break;

    return i;          /* returns the index of the cache structure */
}

static  void    do_cache(int indx)
{
    int       lines_hidden;
    pLineDesc pl;

    if (in_block(curwin->topline)) {
        if (blockfro->paft != NULL) curwin->topline = blockfro->paft;
        else                        curwin->topline = cache[indx].qld;
    }

    if (in_block(curwin->curline)) curwin->curline = cache[indx].qld;

    cache[indx].phd = blockfro;
    cache[indx].ptl = blockto;

    if ((cache[indx].qld->pfwd = blockto->pfwd) != NULL)
        cache[indx].qld->pfwd->paft = cache[indx].qld;

    if ((cache[indx].qld->paft = blockfro->paft) != NULL)
        cache[indx].qld->paft->pfwd = cache[indx].qld;

    blockfro->paft = blockto->pfwd = NULL;

    lines_hidden = 1;
    pl = blockfro;
    while ( pl != blockto ) {
        pl = pl->pfwd;
        lines_hidden++;
    }

    sprintf(cache[indx].qld->ptxt, "      %s%d%4d %s",
                        " Block #", indx, lines_hidden,
                        "lines hidden from display ");

    unmarkblock();
    realign();
}

void  uncache_text(int i)
{
    if (curwin->curline == curwin->topline) {
        if ( curwin->curline->paft ) curwin->topline = curwin->topline->paft;
        else                         curwin->topline = cache[i].phd;

        curwin->curline = curwin->topline;
    }
    else
        curwin->curline = cache[i].phd;

    if ((cache[i].phd->paft = cache[i].qld->paft) != NULL) cache[i].phd->paft->pfwd = cache[i].phd;

    if ((cache[i].ptl->pfwd = cache[i].qld->pfwd) != NULL) cache[i].ptl->pfwd->paft = cache[i].ptl;

    cache[i].phd = cache[i].ptl = NULL;
    cache[i].qld->pfwd = cache[i].qld->paft = NULL;

    realign();
}


void  partial_uncache(int ndx, int lines)
{
    pLineDesc p;
    int       lines_hidden, k;

    if (lines < 0) {
        k = 0;
        p = cache[ndx].ptl;

        while ( p != NULL && k++ < -lines ) p = p->paft;

        if ( p == NULL ) {  uncache_text(ndx);   return;  }

        if ((cache[ndx].ptl->pfwd = cache[ndx].qld->pfwd) != NULL) cache[ndx].ptl->pfwd->paft = cache[ndx].ptl;

        p->pfwd->paft   = cache[ndx].qld;
        cache[ndx].qld->pfwd = p->pfwd;

        cache[ndx].ptl = p;
        cache[ndx].ptl->pfwd = NULL;
    }
    else if (lines > 0) {
        k = 0;
        p = cache[ndx].phd;

        while ( p != NULL && k++ < lines ) p = p->pfwd;

        if ( p == NULL ) {  uncache_text(ndx);   return;  }

        if ((cache[ndx].phd->paft = cache[ndx].qld->paft) != NULL) cache[ndx].phd->paft->pfwd = cache[ndx].phd;

        if (curwin->topline == cache[ndx].qld) curwin->topline = cache[ndx].phd;

        p->paft->pfwd = cache[ndx].qld;
        cache[ndx].qld->paft = p->paft;

        cache[ndx].phd = p;
        cache[ndx].phd->paft = NULL;

    }
    else {  realign();  return;     }

    lines_hidden = 0;
    p = cache[ndx].phd;

    while (p != NULL) {  p = p->pfwd;   lines_hidden++;  }

    sprintf(cache[ndx].qld->ptxt, "      %s%d%4d %s",
                    " Block #", ndx, lines_hidden,
                    "lines hidden from display ");

    realign();
}

static  void    extend_cache(int indx, pLineDesc p) {
    pLineDesc pl;
    int     lines_hidden;

    if (p == blockfro && p == curwin->curline) {
        curwin->curline = cache[indx].qld;
        if (curwin->topline == p) curwin->topline = cache[indx].qld;
        cache[indx].qld->paft->pfwd = cache[indx].phd;
        cache[indx].phd->paft = cache[indx].qld->paft;
        cache[indx].phd = p;
        if ((cache[indx].qld->paft = p->paft) != NULL) cache[indx].qld->paft->pfwd = cache[indx].qld;
        cache[indx].phd->paft = NULL;
    }
    else if (p == blockto && p == curwin->curline) {
        pl = curwin->topline;
        while (pl != p && pl != cache[indx].qld) pl = pl->pfwd;
        curwin->curline = cache[indx].qld;
        if (pl == p) curwin->topline = cache[indx].qld;
        cache[indx].ptl->pfwd = cache[indx].qld->pfwd;
        cache[indx].ptl->pfwd->paft = cache[indx].ptl;
        cache[indx].ptl = p;
        if ((cache[indx].qld->pfwd = blockto->pfwd) != NULL)  cache[indx].qld->pfwd->paft = cache[indx].qld;
        cache[indx].ptl->pfwd = NULL;
    }
    else return;
    lines_hidden = 1;
    pl = cache[indx].phd;
    while ((pl = pl->pfwd) != NULL) lines_hidden++;
    sprintf(cache[indx].qld->ptxt, "      %s%d%4d %s",
                        " Block #", indx, lines_hidden,
                        "lines hidden from display ");
    unmarkblock();
    realign();
}

void  cache_text() {

    int     i;
    pLineDesc p;

    if (blockvalid()) {
        for (i = 0; i < MAXCACHEBLK; i++)
            if (cache[i].phd == NULL) {  do_cache(i);  return;  }

        sprintf(cmdline2, "Cannot cache more than %d blocks", MAXCACHEBLK);
    }
    else if ( (p = blockfro) != NULL ) {
        while ( p != NULL && (i = in_cache(p)) == MAXCACHEBLK ) p = p->pfwd;

        if ( p != NULL ) { extend_cache(i, blockfro);  return; }

        sprintf(cmdline2, "cache extension definition error");
    }
    else if ( (p = blockto) != NULL ) {
        while ( p != NULL && (i = in_cache(p)) == MAXCACHEBLK ) p = p->paft;

        if ( p != NULL ) { extend_cache(i, blockto);  return; }

        sprintf(cmdline2, "cache extension definition error");
    }
    else
        sprintf(cmdline2, "Nothing defined to be cached");

    appcmdline(cmdline2);
    beep();
}