/*
 *       ͻ
 *              Chi Programmer's Editor, Borland C++ 3.1       
 *                     
 *           Copyright (C) 1990,1991,1993                      
 *           Author: Fook H. Eng, 201 West Hilliard Avenue     
 *                   Monterey Park, CA 91754, 818 572-9220     
 *                                                             
 *       ͼ
 */
#include    <stdio.h>
#include    <stdlib.h>
#include    <ctype.h>
#include    <string.h>
#include    "vartypes.h"
#include    "keys.h"
#include    "screen.h"
#include    "cursors.h"
#include    "utils.h"
#include    "memory.h"
#include    "cmd.h"
#include    "windows.h"
#include    "blocks.h"

void    delete_char()       /* formerly misnomered delete_right_char */
{
    int        i;
    pLineDesc lp = curwin->curline;
    WinDesc  * wp = curwin;

    if (wp->colno <= lastchar(lp)) {
        for (i = wp->colno; i <= lp->bufflen - 1; i++)
            lp->ptxt[i-1] = lp->ptxt[i];
        lp->ptxt[lp->bufflen-1] = ' ';
    }
    else joinline();
}

void    delete_left_char()
{
    int        i;
    pLineDesc cl = curwin->curline;
    WinDesc  * cw = curwin;

    if (cw->colno == 1) {
        if(cw->clineno != 1) {
            upline();
            cw->colno = lastchar(curwin->curline) + 1;
            delete_char();
            return;
        }
        else return;
    }

    if (cw->colno > cl->bufflen + 1)
        cw->colno--;
    else {
        for (i = cw->colno - 1; i <= cl->bufflen -1; i++)
            cl->ptxt[i-1] = cl->ptxt[i];
        cl->ptxt[cl->bufflen-1] = ' ';
        cw->colno--;
    }
}

void    backtab()
{
    if (curwin->colno > 1) {
        if ( curwin->colno % tabsize == 1 ) curwin->colno--;
        while ( curwin->colno % tabsize != 1) curwin->colno--;
    }
}


void    puttab()
{
    int     tabpos, endtext;
    WinDesc  * cw = curwin;
    pLineDesc cl = curwin->curline;

    tabpos = cw->colno / tabsize * tabsize + (tabsize + 1);
    if (!cw->insertflag || cw->colno > cl->bufflen)
        cw->colno = tabpos;
    else {
        endtext = cl->bufflen;
        while (endtext > cw->colno && cl->ptxt[endtext-1] == ' ') endtext--;
        if (tabpos - cw->colno >= cl->bufflen - endtext)
            if (!sizeline(cw->curline, endtext + tabpos - cw->colno)) {
                appcmdline("No more memory available");
                return;
            }
        cl = curwin->curline;       /* may have new curwin->curline */
        memmove(&cl->ptxt[tabpos-1], &cl->ptxt[cw->colno-1], endtext - cw->colno + 1);
        memset(&cl->ptxt[cw->colno-1], ' ', tabpos - cw->colno);
        cw->colno = tabpos;
    }
}

void    changecase()
{
    pLineDesc cl = curwin->curline;

    if (isalpha(cl->ptxt[curwin->colno-1]))
        cl->ptxt[curwin->colno-1] ^= 0x20;
}

void    upcaseline()
{
    pchar  pch = curwin->curline->ptxt;
    int    i;

    for (i = 1; i <= curwin->curline->bufflen; i++)
        if (isalpha(pch[i-1])) pch[i-1] &= 0x5f;
}

void    locaseline()
{
    pchar  pch = curwin->curline->ptxt;
    int    i;

    for (i = 1; i <= curwin->curline->bufflen; i++)
        if (isalpha(pch[i-1])) pch[i-1] |= 0x60;
}

static  void delete_span(int c1, int c2)
{
    int     i;
    pLineDesc pl = curwin->curline;

    for (i = c1; i <= pl->bufflen - (c2+1-c1); i++)
        pl->ptxt[i-1] = pl->ptxt[i+c2-c1];

    for (i = pl->bufflen - (c2+1-c1) + 1; i <= pl->bufflen; i++)
        pl->ptxt[i-1] = ' ';
}

static int isother(char ch) {
    return (!isalnum(ch) && !isspace(ch));
}

void    delete_right_word() {

    int         i;
    WinDesc  * pw = curwin;
    pLineDesc pl = curwin->curline;

    if (pw->colno > pl->bufflen) return;

    if (pl->ptxt[pw->colno-1] == ' ') {
        i = pw->colno;

        while (i < pl->bufflen && (pl->ptxt[i] == ' ')) i++;

        delete_span(pw->colno, i);
    }
    else if (isalnum(pl->ptxt[pw->colno-1])) {
        i = pw->colno;

        while (i < pl->bufflen && isalnum(pl->ptxt[i])) i++;
        while (i < pl->bufflen && (pl->ptxt[i] == ' ')) i++;

        delete_span(pw->colno, i);
    }
    else if (isother(pl->ptxt[pw->colno-1])) {
        i = pw->colno;

        while (i < pl->bufflen && isother(pl->ptxt[i])) i++;
        while (i < pl->bufflen && (pl->ptxt[i] == ' ')) i++;

        delete_span(pw->colno, i);
    }
}

void    delete_left_word()
{
    int        lastch, i;
    WinDesc  * pw = curwin;
    pLineDesc pl = curwin->curline;

    if (pw->colno > (lastch = lastchar(pl))) pw->colno = lastch + 1;

    if (pl->ptxt[pw->colno-1] != ' ') pw->colno--;

    i = pw->colno;
    while ( i >= 1 && !isalnum(pl->ptxt[i-1]) ) i--;
    while ( i >= 1 &&  isalnum(pl->ptxt[i-1]) ) i--;

    delete_span(++i, pw->colno);
    pw->colno = i;
}
/***
    In the functions delete_line() and insert_delline() that follows, there is the circular array of
    pointers to line descriptors, LineDesc *  pdellnlist[MAXDELLINE]; and a pointer to pointer to same,
    LineDesc ** ppdelln; Whenever a line is deleted, or its line descriptor is removed from the doubly
    linked chain, it is saved by having one of the array pointers pointing to it.  ppdelln points to
    the line descriptor pointer which will point to the next delete line.  After a deleted line is
    'saved' by having *ppdelln point to it, ppdelln is advanced to point to the next line descriptor
    pointer.  This implementation is analogous to a last in first out circular buffer.  If a line is
    deleted and ppdelln is pointing to a line descriptor pointer which is non-NULL, then resources
    will be returned to the operation system by a call to freetxtdes(*ppdelln) and then *ppdelln is
    assigned to point to the deleted line.  Maximum number of lines that can be saved for retrieval is
    determined by the value MAXDELLINE.  When a line is to be retrieved, ppdelln will regress to point
    to the most recently deleted line.  After the line descriptor is reclaimed, *ppdelln is assigned a
    NULL value, otherwise, the circular buffer can be reclaimed ad infinitum.
                                                                                                  ***/

void delete_line() {
    pLineDesc p = curwin->curline;

    if (p->pfwd != NULL) p->pfwd->paft = p->paft;
    if (p->paft != NULL) p->paft->pfwd = p->pfwd;

    if (p == curwin->topline) {
        if (p->pfwd != NULL)
            curwin->curline = curwin->topline = p->pfwd;
        else if (p->paft != NULL)
            curwin->curline = curwin->topline = p->paft;
        else
            curwin->curline = curwin->topline = maktxtdes(0x10);
    }
    else if (p->pfwd != NULL)
        curwin->curline = p->pfwd;
    else {
        curwin->curline = p->paft;
        curwin->lineno--;
    }

    if (p == blockfro || p == blockto) unmarkblock();

    if (*ppdelln != NULL) freetxtdes(*ppdelln);

    *ppdelln = p;

    if (ppdelln != &pdellnlist[MAXDELLINE-1]) ppdelln++;
    else ppdelln = &pdellnlist[0];

}

void    insert_delline()
{
    if (ppdelln != &pdellnlist[0]) ppdelln--;
    else ppdelln = &pdellnlist[MAXDELLINE-1];

    if (*ppdelln != NULL) {
        (*ppdelln)->paft = curwin->curline->paft;
        (*ppdelln)->pfwd = curwin->curline;
        if (curwin->curline->paft != NULL)
            curwin->curline->paft->pfwd = *ppdelln;
        if (curwin->topline == curwin->curline)
            curwin->topline = *ppdelln;
        curwin->curline->paft = *ppdelln;
        curwin->curline = *ppdelln;
        *ppdelln = NULL;
    }
}

void insert_line(int shifted) {

    pLineDesc pl, cl = curwin->curline;
    WinDesc   * cw = curwin;

    if (cw->insertflag) {
        pl = maktxtdes(1);

        if (shifted) {          //  if key is shifted, insert above curline
            pl->pfwd = cl;
            if ((pl->paft = cl->paft) != NULL) pl->paft->pfwd = pl;
            pl->pfwd->paft = pl;

            if (cw->lineno == 1) cw->topline = pl;
        }
        else {                  //  if key NOT shifted, insert below
            pl->paft = cl;
            if ((pl->pfwd = cl->pfwd) != NULL) pl->pfwd->paft = pl;
            pl->paft->pfwd = pl;

            if (cw->lineno == cw->lastlineno - cw->firstlineno)
                cw->topline = cw->topline->pfwd;
            else
                cw->lineno++;
        }

        cw->colno = max(firstchar(cl), 1);
        cw->curline = pl;
    }
}

void newline()
{
    pLineDesc pl, cl = curwin->curline;
    WinDesc   * cw = curwin;
    int     newlen;

    if (cw->insertflag) {
        newlen = lastchar(cl) - cw->colno + 1;
        pl = maktxtdes(newlen);             /* s'OK! even if newlen is neg */
        pl->pfwd = cl->pfwd;
        pl->paft = cl;

        if (cl->pfwd != NULL) cl->pfwd->paft = pl;
        cl->pfwd = pl;

        if (cw->lineno == cw->lastlineno - cw->firstlineno)
            cw->topline = cw->topline->pfwd;
        else
            cw->lineno++;

        if (newlen > 0) {                   /* don't move no minus amt */
            memmove(pl->ptxt, cl->ptxt + cw->colno - 1, newlen);
            memset(cl->ptxt + cw->colno - 1, ' ', newlen);
        }

        cw->curline = pl;
        cw->colno = 1;

        if (cw->autoindent) indentline();
    }
}

static  int     relative;

static  int     askfornum(pchar st)
{
    char    num[12];

    strcpy(num, askforstring(st));

    relative = strchr("+-", *num) != NULL ? TRUE : FALSE;

    return atoi(num);
}

void    gotolinenum()
{
    int     diff, i;

    diff = askfornum("Enter absolute or relative line number to move to..");
    appcmdline("");

    if (!relative) diff -= curwin->clineno;

    i = 0;
    if (diff < 0) {
        diff = -diff;
        while (curwin->curline->paft != NULL && i++ < diff)
            curwin->curline = curwin->curline->paft;

        if (i > curwin->lineno) {
            curwin->topline = curwin->curline;
            realign();
            linehalfdown();
        }
    }
    else if (diff > 0) {
        while (curwin->curline->pfwd != NULL && i++ < diff)
            curwin->curline = curwin->curline->pfwd;

        if (i > curwin->lastlineno-curwin->firstlineno-curwin->lineno+1) {
            curwin->topline = curwin->curline;
            realign();
            linehalfdown();
        }
    }
    refresh_screen();
}