/*
 *       ͻ
 *              Chi Programmer's Editor, Borland C++ 3.1       
 *                     
 *           Copyright (C) 1990,1991,1993                      
 *           Author: Fook H. Eng, 201 West Hilliard Avenue     
 *                   Monterey Park, CA 91754, 818 572-9220     
 *                                                             
 *       ͼ
 */
#include    <stdio.h>
#include    <stdlib.h>
#include    <ctype.h>
#include    "vartypes.h"
#include    "screen.h"
#include    "cursors.h"
#include    "utils.h"
#include    "windows.h"

static  void    advanceline(void);
static  void    uphalfpage(void);
static  void    downhalfpage(void);

void    upword()
{
    while (curwin->curline->paft != NULL &&
               (curwin->colno <= curwin->curline->bufflen &&
                curwin->curline->ptxt[curwin->colno-1] != ' ')) upline();

    while (curwin->curline->paft != NULL &&
               (curwin->colno > curwin->curline->bufflen ||
                curwin->curline->ptxt[curwin->colno-1] == ' ')) upline();
}

void    downword()
{
    while (curwin->curline->pfwd != NULL &&
               (curwin->colno <= curwin->curline->bufflen &&
                curwin->curline->ptxt[curwin->colno-1] != ' ')) downline();

    while (curwin->curline->pfwd != NULL &&
               (curwin->colno > curwin->curline->bufflen ||
                curwin->curline->ptxt[curwin->colno-1] == ' ')) downline();
}


void    scroll_right(int ncols)
{

    curwin->leftedge =
                min(MAXLINELENGTH - logscrcols, curwin->leftedge + ncols);

    if (curwin->colno < curwin->leftedge)
        curwin->colno = curwin->leftedge;

    updwindow(curwin);

}

void    scroll_left(int ncols)
{

    curwin->leftedge = max(1, curwin->leftedge - ncols);

    if (curwin->colno > curwin->leftedge + logscrcols - 1)
        curwin->colno = curwin->leftedge + logscrcols - 1;

    updwindow(curwin);

}

void    scroll_up()
{
    if (curwin->topline->paft != NULL) {
        curwin->topline = curwin->topline->paft;
        if (curwin->lineno == curwin->lastlineno - curwin->firstlineno) {
            curwin->clineno--;
            curwin->curline = curwin->curline->paft;
        }
        else curwin->lineno++;
    }
}


void    scroll_down()
{
    if (curwin->topline->pfwd != NULL) {
        curwin->topline = curwin->topline->pfwd;
        if (curwin->lineno == 1) {
            curwin->clineno++;
            curwin->curline = curwin->curline->pfwd;
        }
        else curwin->lineno--;
    }
}


void    leftchar()
{
    if (curwin->colno > 1) {
        curwin->colno--;
        if (curwin->colno < curwin->leftedge)
            curwin->leftedge = curwin->colno;
    }
}


void    rightchar()
{
    if (curwin->colno < MAXLINELENGTH) curwin->colno++;
}

/*  gotta address six cases:
    1) colno = 1;                    2) 1 < colno <= firstalpha;
    3) bufflen < colno;              4) in space after firstalpha;
    5) in word but not first letter; 6) in word and is first letter;     */

static int isother(char ch) {
    return (!isalnum(ch) && !isspace(ch));
}

void    leftword() {

    pLineDesc cl = curwin->curline;
    WinDesc     * w  = curwin;

    if (w->colno > cl->bufflen) w->colno = cl->bufflen;

    if (w->colno == 1) {
        upline();
        endkey();
    }

    else if (isspace(cl->ptxt[w->colno-1])) {
        while (w->colno > 1 && isspace(cl->ptxt[w->colno-1])) w->colno--;
        //  if (w->colno != 1 && !isspace(cl->ptxt[w->colno-2])) leftword();

        if (w->colno == 1) donothing();
        else if (isalnum(cl->ptxt[w->colno-1])) {
            if (!isalnum(cl->ptxt[w->colno-2])) donothing();
            else leftword();
        }
        else if (isother(cl->ptxt[w->colno-1])) {
            if (isspace(cl->ptxt[w->colno-2])) donothing();
            else leftword();
        }

    }
    else if (isother(cl->ptxt[w->colno-1])) {
        if (isother(cl->ptxt[w->colno-2])) {
            while (w->colno > 1 && isother(cl->ptxt[w->colno-1])) w->colno--;
            if (isspace(cl->ptxt[w->colno-1]))
                w->colno++;
            else if (w->colno > 1 && isalnum(cl->ptxt[w->colno-2]))
                leftword();
        }
        else if (isalnum(cl->ptxt[w->colno-2])) {
            if (w->colno > 2 && isalnum(cl->ptxt[w->colno-3])) {
                w->colno--;
                leftword();
            }
            else
                w->colno--;
        }
        else {
            w->colno--;
            if (w->colno > 1) leftword();
        }
    }
    else if (isalnum(cl->ptxt[w->colno-1])) {
        if (isalnum(cl->ptxt[w->colno-2])) {
            while (w->colno > 0 && isalnum(cl->ptxt[w->colno-1])) w->colno--;
            w->colno++;
        }
        else if (isother(cl->ptxt[w->colno-2])) {
            w->colno--;
            if (w->colno > 1 && !isspace(cl->ptxt[w->colno-2])) leftword();
        }
        else if (isspace(cl->ptxt[w->colno-2])) {
            w->colno--;
            if (w->colno > 1) leftword();
        }
    }
}

static  void    advanceline()
{
    WinDesc   * wp  = curwin;

    if (wp->curline->pfwd != NULL) {
        wp->curline = wp->curline->pfwd;
        wp->clineno++;
        if (wp->lineno == wp->lastlineno - wp->firstlineno)
            wp->topline = wp->topline->pfwd;
        else
            wp->lineno++;
        wp->colno = 1;
    }
}

void    rightword() {
    WinDesc  * wp = curwin;
    pLineDesc lp = curwin->curline;
    int        lastch;

    lastch =  lastchar(lp);

    if (wp->colno > lp->bufflen || lastch == 0 || wp->colno > lastch)
        advanceline();
    /****
    else if (lp->ptxt[wp->colno-1] != ' ') {
        while (wp->colno <= lastch &&
                         isalnum(lp->ptxt[wp->colno-1])) wp->colno++;
        while (wp->colno <= lastch &&
                        !isalnum(lp->ptxt[wp->colno-1])) wp->colno++;
    }
    else while (lp->ptxt[wp->colno-1] == ' ') wp->colno++;
    ****/
    else if (isalnum(lp->ptxt[wp->colno-1])) {
        while (wp->colno <= lastch && isalnum(lp->ptxt[wp->colno-1]))
            wp->colno++;
        if (isother(lp->ptxt[wp->colno-1])) {
            while (wp->colno <= lastch && isother(lp->ptxt[wp->colno-1]))
                wp->colno++;
            while (wp->colno <= lastch && isspace(lp->ptxt[wp->colno-1]))
                wp->colno++;
        }
        else
            while (wp->colno <= lastch && isspace(lp->ptxt[wp->colno-1]))
                wp->colno++;
    }
    else if (isother(lp->ptxt[wp->colno-1])) {
        while (wp->colno <= lastch && isother(lp->ptxt[wp->colno-1]))
            wp->colno++;
        while (wp->colno <= lastch && isspace(lp->ptxt[wp->colno-1]))
            wp->colno++;
    }
    else
        while (wp->colno <= lastch && isspace(lp->ptxt[wp->colno-1]))
            wp->colno++;
}

void    upline()
{
    if (curwin->curline->paft != NULL) {
        curwin->clineno--;
        curwin->curline = curwin->curline->paft;
        if (curwin->lineno == 1)
            curwin->topline = curwin->topline->paft;
        else
            curwin->lineno--;
        updwinsl(curwin);
    }
}

void    downline()
{
    if (curwin->curline->pfwd != NULL) {
        curwin->clineno++;
        curwin->curline = curwin->curline->pfwd;

        if (curwin->lineno == curwin->lastlineno - curwin->firstlineno)
            curwin->topline = curwin->topline->pfwd;
        else
            curwin->lineno++;

        updwinsl(curwin);
    }
}

void    uppage()
{
    int     pagesize, i;
    WinDesc *   wp = curwin;

    if (wp->curline != wp->topline) {
        wp->curline = wp->topline;
        return;
    }

    if (wp->topline->paft != NULL) {
        pagesize = wp->lastlineno - wp->firstlineno;
        for (i = 1; i < pagesize; i++) {
            wp->topline = wp->topline->paft;
            if (wp->topline->paft == NULL) break;
        }
    }

    wp->curline = wp->topline;
}

static  void    uphalfpage()
{
    int     pagesize, i;
    WinDesc *   wp = curwin;

    if (wp->topline->paft == NULL)
        return;
    else {
        pagesize = (wp->lastlineno - wp->firstlineno) / 2;
        for (i = 1; i < pagesize; i++) {
            wp->topline = wp->topline->paft;
            wp->curline = wp->curline->paft;
            if (wp->topline->paft == NULL) break;
        }
    }
}

void    downpage()
{
    int     pagesize, i;
    WinDesc *   wp = curwin;
    pLineDesc  bottomline;

    bottomline = wp->topline;
    for (i = wp->firstlineno;;) {
        if (bottomline->pfwd == NULL || ++i == wp->lastlineno) break;
        else bottomline = bottomline->pfwd;
    }

    if (wp->curline != bottomline) {
        wp->curline = bottomline;
        return;
    }

    if (wp->curline->pfwd != NULL) {
        pagesize = wp->lastlineno - wp->firstlineno;
        for (i = 1; i < pagesize; i++) {
            wp->topline = wp->topline->pfwd;
            wp->curline = wp->curline->pfwd;
            if (wp->curline->pfwd == NULL) break;
        }
    }
    wp->curline = wp->topline;
    for (i = wp->firstlineno;;) {
        if (wp->curline->pfwd == NULL || ++i == wp->lastlineno) break;
        else wp->curline = wp->curline->pfwd;
    }
}

static  void    downhalfpage()
{
    int     pagesize, i;
    WinDesc *   wp = curwin;

    if (wp->curline->pfwd == NULL)
        return;
    else {
        pagesize = (wp->lastlineno - wp->firstlineno) / 2;
        for (i = 1; i < pagesize; i++) {
            wp->topline = wp->topline->pfwd;
            wp->curline = wp->curline->pfwd;
            if (wp->curline->pfwd == NULL) break;
        }
    }
}

/*
 *  current line is scrolled half way toward the window top.
 */
void    linehalfup()
{
    int     dest_lineno;

    dest_lineno = (curwin->lineno + 1) / 2;
    while (curwin->lineno > dest_lineno) {
        curwin->topline = curwin->topline->pfwd;
        curwin->lineno--;
    }
}

/*
 *  current line is scrolled half way toward the bottom of window.
 */
void    linehalfdown()
{
    int     dest_lineno;
    WinDesc  * cw = curwin;

    dest_lineno = (cw->lineno + cw->lastlineno - cw->firstlineno + 1) / 2;
    while (cw->lineno < dest_lineno && cw->topline->paft != NULL) {
        cw->topline = cw->topline->paft;
        cw->lineno++;
    }
}

/*
 *  cursor moves up halfway to top. screen does not scroll.
 */
void    cursorhalfup()
{
    int     dest_lineno;

    dest_lineno = (curwin->lineno + 1) / 2;
    while (curwin->lineno > dest_lineno) {
        curwin->curline = curwin->curline->paft;
        curwin->lineno--;
    }
}


/*
 *  cursor moves down halfway to bottom.  screen does not scroll.
 */
void    cursorhalfdown()
{
    int     destno;
    WinDesc  * cw = curwin;

    destno = (cw->lastlineno - cw->firstlineno + cw->lineno + 1) / 2;
    while (cw->lineno < destno && cw->curline->pfwd != NULL) {
        cw->curline = cw->curline->pfwd;
        cw->lineno++;
    }
}


void    cursorhalfleft()
{
    curwin->colno = (curwin->colno + 1) / 2;
}


void    cursorhalfright()
{
    int     i = lastchar(curwin->curline);

    if (i != 0 && curwin->colno <= i)
        curwin->colno = (i + curwin->colno) / 2 + 1;
    else
        curwin->colno = i + 1;
}


/*
 *  the current line is scrolled to the top of the window.
 */
void    currenttop()
{
    if (curwin->topline == curwin->curline) uphalfpage();
    else curwin->topline = curwin->curline;
}

/*
 *  the current line is scrolled to the bottom of the window.
 */
void    currentbottom()
{
    WinDesc  * cw = curwin;

    if (cw->lineno == cw->lastlineno - cw->firstlineno) downhalfpage();
    else while (cw->topline->paft != NULL &&
                cw->lineno < cw->lastlineno - cw->firstlineno) {
        cw->topline = cw->topline->paft;
        cw->lineno++;
    }
}

/*
 *  moves the cursor to the top of the window sans scrolling.
 */
void    windowtopline()
{
    if (curwin->curline == curwin->topline) uppage();
    curwin->curline = curwin->topline;
}

/*
 *  moves the cursor to the bottom of the window sans scrolling.
 */
void    windowbottomline()
{
    WinDesc  * cw = curwin;

    if (cw->lineno == cw->lastlineno - cw->firstlineno) downpage();

    while (cw->curline->pfwd != NULL &&
                cw->lineno < cw->lastlineno - cw->firstlineno) {
        cw->curline = cw->curline->pfwd;
        cw->lineno++;
    }
}

void windowtopfile() {

    pLineDesc p = curwin->topline;

    while (p->paft != NULL) p = p->paft;
    curwin->topline = p;
    curwin->curline = p;
    realign();
}

void windowbottomfile() {
    pLineDesc  p;

    p = curwin->curline;
    while (p->pfwd != NULL) p = p->pfwd;

    curwin->curline = p;
    realign();
}

void    endkey()
{
    curwin->colno = lastchar(curwin->curline) + 1;
}

void    endline()
{
    int     lastposn;

    lastposn = lastchar(curwin->curline) + 1;

    if (curwin->colno != lastposn)
        curwin->colno = lastposn;
    else if (curwin->lineno < curwin->lastlineno - curwin->firstlineno) {
        windowbottomline();
        curwin->colno = 1;
    }
    else {
        windowbottomfile();
        curwin->colno = 1;
    }
}

void    homekey()
{
    curwin->colno = 1;
}

void    homeline()
{
    if (curwin->colno != 1)
        curwin->colno = 1;
    else if (curwin->curline != curwin->topline)
        curwin->curline = curwin->topline;
    else {
        windowtopfile();
        curwin->colno = 1;
    }
}