/*
 *       ͻ
 *              Chi Programmer's Editor, Borland C++ 3.1       
 *                     
 *           Copyright (C) 1990,1991,1993                      
 *           Author: Fook H. Eng, 201 West Hilliard Avenue     
 *                   Monterey Park, CA 91754, 818 572-9220     
 *                                                             
 *       ͼ
 */
#include    <stdio.h>
#include    <alloc.h>
#include    <stdlib.h>
#include    <dos.h>
#include    <string.h>
#include    "vartypes.h"
#include    "memory.h"
#include    "utils.h"
#include    "qcmd.h"
#include    "screen.h"
#include    "blocks.h"
#include    "files.h"
#include    "windows.h"
#include    "cache.h"

static FILE * ffp;
static int  need_crlf = TRUE;

void    readfile() {
    pchar pfn;

    pfn = askforstring("Enter file name:");

    if (pfn != NULL && !reatxtfil(pfn)) {
        sprintf(cmdline2, "Problem opening file %s", pfn);
        beep();
        appcmdline(cmdline2);
    }
    else {
        realign();
        appcmdline("");
    }
}

void    renamefile() {
    pchar pfn;

    pfn = askforstring("Enter new name for text stream:");

    if (pfn != NULL) strcpy(curwin->filename, pfn);
}

void    filesave(pchar fname) {
    pLineDesc  pl;
    int        i;

    if (strlen(fname) == NULL)
        return;
    else {
        sprintf(cmdline2, "Saving file %s..", fname);
        appcmdline(cmdline2);
    }

    unmarkblock();

    for (i = 0; i < MAXCACHEBLK; i++)
        if (in_window(curwin, cache[i].qld)) uncache_text(i);

    pl = curwin->topline;

    while (pl->paft != NULL) pl = pl->paft;

    write_to_file(fname, pl, NULL);
}

void    cpfilesave()
{
    sprintf(cmdline2, "Save changes to file %s? [y/n] ", curwin->filename);

    if (getyesno(cmdline2)) {
        filesave(curwin->filename);
        sprintf(cmdline2, "files saved to %s", curwin->filename);
        appcmdline(cmdline2);
    }
    else appcmdline("");
}

void    cpfileexit()
{
    sprintf(cmdline2, "Exit editor without saving %s? [y/Y/n] ", curwin->filename);

    if (getyesno(cmdline2)) rundown = TRUE;
    else appcmdline("");
}


void    cpfilewrite()
{
    char  pfn[64];
    pchar pc;

    if ((pc = askforstring("Enter filename to write to:")) != NULL) {

        strcpy(pfn, pc);

        if (blockvalid() && in_window(curwin, blockfro)) {
            write_to_file(pfn, blockfro, blockto);
            sprintf(cmdline2, "block saved to %s", pfn);
            unmarkblock();
        }
        else {
            filesave(pfn);
            sprintf(cmdline2, "file saved to %s", pfn);
        }

        appcmdline(cmdline2);
    }
}


static  int     insbuf(int amt)   /* resource allocated even if amt == 0 */
{
    register pLineDesc pl;
    register WinDesc  * pw = curwin;

    if ((pl = maktxtdes(amt)) == NULL) return FALSE;

    pl->paft = pw->curline;
    pl->pfwd = pw->curline->pfwd;
    pl->inblock = FALSE;
    pw->curline->pfwd = pl;

    if (pl->pfwd != NULL) pl->pfwd->paft = pl;

    pw->curline = pl;

    if (pw->lineno == (pw->lastlineno - pw->firstlineno))
        pw->topline = pw->topline->pfwd;
    else
        pw->lineno++;

    return TRUE;
}


static int readaline (pchar line)
{
    int     len;

    if (fgets(line, MAXLINELENGTH, ffp) == NULL) return EOF;

    len = strlen(line);

    if (line[len-1] == '\n') len--;
    else need_crlf = FALSE;

    return len;
}


static int  putaline(pchar tline, int tlen)
{
    if (!insbuf(tlen)) {
        appcmdline ("File too big!  Partial file read.");
        return FALSE;
    }
    else if (tlen > 0)
        memmove (curwin->curline->ptxt, tline, tlen);

    return TRUE;
}

int  reatxtfil(pchar fn) {
    char    tline[MAXLINELENGTH];
    int     tlen, i, deltop;
    pLineDesc topsave, cursave;

    if ((ffp = fopen(fn, "rt")) == NULL)  return FALSE;

    if (strcmp(curwin->filename, "nofile") == 0)
        strcpy (curwin->filename, fn);

    topsave = curwin->topline;
    cursave = curwin->curline;
    deltop = is_emptyline(topsave) &&
                (topsave->pfwd == NULL) && (topsave->paft == NULL);

    while ((tlen = readaline(tline)) != EOF)
        if (!putaline(tline, tlen)) break;

    if (need_crlf) putaline(tline, 0);

    fclose (ffp);

    curwin->topline = topsave;
    curwin->curline = cursave;

    if (deltop) {
        curwin->curline = curwin->curline->pfwd;
        curwin->curline->paft = NULL;
        freetxtdes(curwin->topline);
        curwin->topline = curwin->curline;
    }

    return TRUE;
}

int     file_exist(pchar fname)
{
    FILE    * ffp;

    if ((ffp = fopen(fname, "r")) == NULL)
        return FALSE;
    else {
        fclose (ffp);
        return TRUE;
    }
}

void file_read(pchar fname) {

    if (*fname == '\0') return;

    reatxtfil(fname);
    realign();
}

void write_to_file(pchar fname, pLineDesc start, pLineDesc finish) {
    FILE*       outfile;
    int         c;
    pLineDesc   pl;
    VARSTRING   tline;

    if (strlen(fname) == 0) {
        appcmdline("No filename to write to");  return;
    }
    else if (start == NULL) {
        appcmdline("No block defined");  return;
    }

    if ((outfile = fopen(fname, "wb")) == NULL) {
        appcmdline("File creation error");  return;
    }

    pl = start;

    /*****
    while (pl != NULL) {
        c = pl->bufflen;
        while (c > 0 && pl->ptxt[c-1] == ' ') c--;

        if (c > 0 || pl->pfwd != NULL) {
            strncpy(tline, pl->ptxt, c);
            tline[c++] = '\r';
            tline[c++] = '\n';
            fwrite(tline, 1, c, outfile);
        }

        pl = (pl == finish) ? NULL : pl->pfwd;
    }
    this version supplies a crlf for even the last line unconditionally
    *****/


    //  following version does not supply crlf gratis.

    while (pl != NULL) {
        c = pl->bufflen;
        while (c > 0 && pl->ptxt[c-1] == ' ') c--;

        if (c > 0 || pl->pfwd != NULL) {
            strncpy(tline, pl->ptxt, c);
        }
        pl = (pl == finish) ? NULL : pl->pfwd;

        if (pl != NULL) {
            tline[c++] = '\r';
            tline[c++] = '\n';
        }
        fwrite(tline, 1, c, outfile);
    }

    fclose(outfile);
}

int load_macros(pchar macrofile)
{
    int     i, k;
    FILE  * infile;

    if ((infile = fopen(macrofile, "rt")) == NULL) {
        beep();
        sprintf(cmdline2, "macro file %s does not exist", macrofile);
        appcmdline(cmdline2);
        return FALSE;
    }

    for (k = 0; k < 8; k++) {
        if (fgets(macstr[k], 63, infile) == NULL) break;

        for (i = 0; i < 64; i++) {
            if (macstr[k][i] == '~') macstr[k][i] = 0x0d;
            else if (macstr[k][i] == '\n') {
                macstr[k][i] = '\0';
                break;
            }
            else if (macstr[k][i] == '\0') break;
        }
    }

    fclose(infile);
    return TRUE;
}