/*
 *       ͻ
 *              Chi Programmer's Editor, Borland C++ 3.1       
 *                     
 *           Copyright (C) 1990,1991,1993                      
 *           Author: Fook H. Eng, 201 West Hilliard Avenue     
 *                   Monterey Park, CA 91754, 818 572-9220     
 *                                                             
 *       ͼ
 */
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <alloc.h>
#include    "vartypes.h"
#include    "memory.h"
#include    "cache.h"
#include    "utils.h"
#include    "blocks.h"

void    freetxtdes(pLineDesc p)    { free (p->ptxt);  free (p); }

void    freeblock(pLineDesc pfro, pLineDesc pto) {

    pLineDesc p, q;

    if (!blockvalid()) return;

    p = pfro;
    while (p != pto) {
        q = p->pfwd;
        freetxtdes(p);
        p = q;
    }
    freetxtdes(p);
}


pLineDesc maktxtdes(int len)
{
    pLineDesc pld;
    int     bufsize;

    /*  If asked for core is less than 0x10, even negative, make it 0x10.
        Otherwise, make it a multiple of 0x10 not greater than requested */

    bufsize = len < 0x10 ? 0x10 : len + 0x0f & 0x3f0;   /* 0x400 is MAXLINELENGTH */

    if (coreleft() < 0x800) return NULL;

    if ((pld = (pLineDesc) malloc (sizeof(LineDesc))) == NULL)
        return NULL;
    else if ((pld->ptxt = (pchar) malloc (bufsize)) == NULL) {
        free (pld);
        return NULL;
    }

    pld->bufflen = bufsize;
    pld->inblock = FALSE;
    pld->pfwd = NULL;
    pld->paft = NULL;
    memset (pld->ptxt, ' ', bufsize);

    return pld;
}

int  sizeline (pLineDesc p, int ncols)
{
    pchar  q;
    int    len;

    if (p->bufflen >= ncols) return TRUE;
    else if ((len = ncols + 0x0f & 0xfff0) > MAXLINELENGTH) return FALSE;
    else if (coreleft() <= 0x800) return FALSE;
    else if ((q = (pchar) malloc (len)) == NULL) return FALSE;
    else {
        memset (q, ' ', len);
        memmove (q, p->ptxt, p->bufflen);
        free (p->ptxt);
        p->ptxt = q;
        p->bufflen = len;
        return TRUE;
    }
}

WinDesc  * creat_window(int top, int len, pchar fn, int row, int col)
{
    WinDesc     * p;
    int     i;

    p = winstack;
    winstack = winstack->pfwd;

    p->pfwd = NULL;
    strcpy (p->filename, fn);
    p->insertflag = TRUE;
    p->autoindent = TRUE;
    p->firstlineno = top;
    p->lastlineno = top + len - 1;
    p->lineno = row;
    p->colno = col;
    p->clineno = 0;
    p->leftedge = 1;

    if ((p->topline = maktxtdes (1)) != NULL) {
        p->curline = p->topline;
        return (p);
    }
    else
        return NULL;
}

int     joinline()
{
    register pLineDesc pl = curwin->curline->pfwd;
    register WinDesc  * pw = curwin;
    int      newlen, lastch, firstch;

    if (pl != NULL && !in_block(pl) && in_cache(pl) == MAXCACHEBLK) {

        if ((firstch = firstchar(pl)) != 0) {

            newlen = pw->colno + (lastch = lastchar(pl)) - firstch;

            if (!sizeline(pw->curline, newlen)) {
                appcmdline("Line too long or no more memory");
                return FALSE;
            }
            else memmove(&pw->curline->ptxt[pw->colno-1],
                         &pl->ptxt[firstch-1], lastch-firstch+1);
        }

        pw->curline->pfwd = pl->pfwd;
        if (pl->pfwd != NULL) pl->pfwd->paft = pw->curline;
        freetxtdes(pl);
        return TRUE;
    }
    else return FALSE;
}