/*
 *       ͻ
 *              Chi Programmer's Editor, Borland C++ 3.1       
 *                     
 *           Copyright (C) 1990,1991,1993                      
 *           Author: Fook H. Eng, 201 West Hilliard Avenue     
 *                   Monterey Park, CA 91754, 818 572-9220     
 *                                                             
 *       ͼ
 */
#include    <stdio.h>
#include    <dos.h>
#include    <string.h>
#include    <stdlib.h>
#include    "vartypes.h"
#include    "utils.h"
#include    "screen.h"
#include    "keys.h"
#include    "blocks.h"

    /************

    The command line is the topmost line of the window.              = 1
    The firstlineno  is the status line of the window.               = 2
    Text line starts on the line following the status line.          = 3
    The lastlineno is the last textline in the window.               = 19
    The firstlineno  is the status line of 2nd window.               = 20
    Text line of 2nd window starts after this line.                  = 21
    The lastlineno is the last textline in the window.               = 36
    The top text line of the screen is 1. (curwin->lineno = 1)
    curwin->lineno varies from 1 to lastlineno-firstlineno.
    curwin->clineno varies from 1 to however many lines in the textfile.
    The bottom text line of screen is lastlineno-firstlineno.
        19-2 = 17 or 36-20 = 16 respectively in our example.


    Note: example data taken from a 80x36 screen format with
          unmodified split screen.
                                  ***************/

void    refresh_screen(void) {

    hscroll();
    if (updcurflag) {
        updcurflag = FALSE;
        gotoXY(curwin->colno - curwin->leftedge + 1,
               curwin->firstlineno + curwin->lineno);
    }
    curwin->clineno = genlineno(curwin);
    markblock();
    updphyscr();
}

void    hscroll() {

    WinDesc *   p = curwin;

    if (p->colno > p->leftedge + logscrcols - 1)
        p->leftedge = p->colno - logscrcols + 1;

    if (p->colno < p->leftedge) p->leftedge = p->colno;
}

int     genlineno(WinDesc * pw) {

        pLineDesc pl = pw->curline;
        int         i = 1;

        for (; pl->paft != NULL; pl = pl->paft, i++)    ;

        return i;
}



void    updwindow(WinDesc * p) {

    char    text[MAXLINELENGTH];
    pLineDesc q;
    int     len, row, color;

    q = p->topline;
    row = p->firstlineno + 1;
    do {
        if (keypressed()) return;
        if (q != NULL) {
            len = min(max(q->bufflen - p->leftedge + 1, 0), logscrcols);
            color = q->inblock ? bordcolor : txtcolor;
            memset(text, ' ', defnocols);
            memmove(text, q->ptxt + p->leftedge - 1, len);
            update_row(text, row, color);
            q = q->pfwd;
        }
        else {
            memset(text, ' ', defnocols);
            update_row(text, row, txtcolor);
        }
        row++;
    } while (row <= p->lastlineno);
    updwinsl(p);
}

void    updphyscr() {

    char    text[MAXLINELENGTH];
    int     len, row, color;
    WinDesc   * pw  = curwin;
    pLineDesc cl = curwin->curline;

    len = min(max(cl->bufflen - pw->leftedge + 1, 0), logscrcols);
    color = (cl->inblock) ? bordcolor : txtcolor;
    row = pw->firstlineno + pw->lineno;
    memset(text, ' ', defnocols);
    memmove(text, cl->ptxt + pw->leftedge-1, len);
    update_row(text, row, color);

    updwindow(pw);                 /* update this window. if another exist */

    if (pw != pw->pfwd) updwindow(pw->pfwd);   /* update that window too   */
}


static  pchar ast[] = {
       "",
       "͸",
       "                                                 Aug 10 1990 ",
       "                                                             ",
       "                                                             ",
       "                                                             ",
       "     An editor to maintain structured programming codes      ",
       "            Fook H. Eng, 201 West Hilliard Avenue            ",
       "           Monterey Park, CA 91754    818-572-9220           ",
       "                                                             ",
       "              press ALT-H at anytime for help                ",
       ";",
       ""  };


static  pchar marq[][4] = {
                    { "      ",
                      "                       ",
                      "                       ",
                      "      "  },

                    { "      ͻ",
                      "                       ",
                      "                       ",
                      "      ͼ"  },


                    { "      ͻ",
                      "                      ",
                      "                        ",
                      "      ͼ"  },

                    { "      ͻ",
                      "                      ",
                      "                        ",
                      "      "  } };

static int  ux, uy, attr;

void do_logo() {

    int     i, j, k;
    int     ast_len  = strlen(ast[0]);
    int     marq_len = strlen(marq[0][0]);
    int     ast_size = sizeof(ast) / sizeof(pchar);

    ux = (defnocols - ast_len) / 2 + 1;
    uy = (defnorows - ast_size) / 2 + 2;
    sprintf(ast[2], "%s%s%s",
       "                                                 ", __DATE__, " ");
       //  the space filler, Aug 10 1990, is replaced with date of compilation

    attr = bordcolor << 8;

    for (i = 0; i < ast_size; i++) {
        for (j = 0; j < ast_len; j++)
            vrow[j] = attr | ast[i][j] & 0xff;
        __vram(__vptr(ux, uy + i), (int far*)vrow, ast_len);
    }

    ux = (defnocols - marq_len + 1) / 2;

    while (!keypressed())
        for (k = 0; k < 4; k++) {
            for (i = 0; i < 4; i++) {
                for (j = 0; j < marq_len; j++)
                    vrow[j] = attr | marq[k][i][j] & 0xff;
                __vram(__vptr(ux, uy+2+i), (int far*)vrow, marq_len);
            }
            delay(100);
        }

    if ( !abortcmd )
        if ( getinput() == '\0' ) getinput();

    refresh_screen();
}

static pchar cst[] = {
     "             C++ Operator Precedence and Associativity             ",
     "ͻ",
     " primary expressions             binary and ternary operators   ",
     " 17R       ::      global scope  13L        *  /  %    multiply ",
     " 17L       ::       class scope  12L        +     -    additive ",
     " 16L     ->  .       mem select  11L        <<   >>       shift ",
     " 16L       []         arr index  10L       < > <= >=   equality ",
     " 16L       ()         func call   9L        ==   !=    equality ",
     " 16L       ()       type constr   8L           &        bit AND ",
     " 15R     sizeof       byte size   7L           ^        bit XOR ",
     " 15R     ++  --       incr/decr   6L           |        bit  OR ",
     " 15R       ~            bit NOT   5L          &&      logic AND ",
     " 15R       !            log NOT   4L          ||      logic  OR ",
     " 15R      +  -            unary   3R          ? :       ternary ",
     " 15R      *  &       deref/addr   2R     = += -= /= %=   assign ",
     " 15R       ()        conversion   2R       <<=  >>=      assign ",
     " 15R   new  delete  stor mngmnt   2R      &=  ^=  |=     assign ",
     " 14L    ->*  .*     mem ptr sel   1L           ,          comma ",
     "ͼ",
     "                    any key to return to Editor                    "   };



void    C_precedence() {

    int     i, j;
    int     cst_len = strlen(cst[0]);
    int     cst_size = sizeof(cst) / sizeof(pchar);

    ux = (defnocols - cst_len) / 2 + 1;
    uy = (defnorows - cst_size) / 2 + 2;
    attr = bordcolor << 8;
    gotoXY(1, 1);

    for (i = 0; i < cst_size; i++) {
        for (j = 0; j < cst_len; j++)
            vrow[j] = attr | cst[i][j] & 0xff;
        __vram(__vptr(ux, uy + i), (int far*)vrow, cst_len);
    }

    while (!keypressed()) donothing();

    if ( !abortcmd )
        if ( getinput() == '\0' ) getinput();

}

static  pchar ascii[][20] = {
    { "                      ASCII Character Code Chart                   ",
      "ͻ",
      "00   nul10  dle 20  sp 30  0  40  @  50  P  60  `  70  p ",
      "01  soh11  dc1 21  !  31  1  41  A  51  Q  61  a  71  q ",
      "02  stx12  dc2 22  \"  32  2  42  B  52  R  62  b  72  r ",
      "03  etx13  dc3 23  #  33  3  43  C  53  S  63  c  73  s ",
      "04  eot14  dc4 24  $  34  4  44  D  54  T  64  d  74  t ",
      "05  enq15  nak 25  %  35  5  45  E  55  U  65  e  75  u ",
      "06  ack16  syn 26  &  36  6  46  F  56  V  66  f  76  v ",
      "07  del17  etb 27  '  37  7  47  G  57  W  67  g  77  w ",
      "08  bs 18  can 28  (  38  8  48  H  58  X  68  h  78  x ",
      "09 	 ht 19  em  29  )  39  9  49  I  59  Y  69  i  79  y ",
      "0A   lf 1A   sub 2A  *  3A  :  4A  J  5A  Z  6A  j  7A  z ",
      "0B  vt 1B  esc 2B  +  3B  ;  4B  K  5B  [  6B  k  7B  { ",
      "0C  ff 1C  fs  2C  ,  3C  <  4C  L  5C  \\  6C  l  7C  | ",
      "0D   cr 1D  gs  2D  -  3D  =  4D  M  5D  ]  6D  m  7D  } ",
      "0E  so 1E  rs  2E  .  3E  >  4E  N  5E  ^  6E  n  7E  ~ ",
      "0F  si 1F  us  2F  /  3F  ?  4F  O  5F  _  6F  o  7F    ",
      "ͼ",
      "         Space bar for next screen, Esc to return to Editor        " },

    { "                      ASCII Character Code Chart                   ",
      "ͻ",
      " 80     90     A0    B0    C0    D0    E0    F0   ",
      " 81     91     A1    B1    C1    D1    E1    F1   ",
      " 82     92     A2    B2    C2    D2    E2    F2   ",
      " 83     93     A3    B3    C3    D3    E3    F3   ",
      " 84     94     A4    B4    C4    D4    E4    F4   ",
      " 85     95     A5    B5    C5    D5    E5    F5   ",
      " 86     96     A6    B6    C6    D6    E6    F6   ",
      " 87     97     A7    B7    C7    D7    E7    F7   ",
      " 88     98     A8    B8    C8    D8    E8    F8   ",
      " 89     99     A9    B9    C9    D9    E9    F9   ",
      " 8A     9A     AA    BA    CA    DA    EA    FA   ",
      " 8B     9B     AB    BB    CB    DB    EB    FB   ",
      " 8C     9C     AC    BC    CC    DC    EC    FC   ",
      " 8D     9D     AD    BD    CD    DD    ED    FD   ",
      " 8E     9E     AE    BE    CE    DE    EE    FE   ",
      " 8F     9F     AF    BF    CF    DF    EF    FF    ",
      "ͼ",
      "         Space bar for next screen, Esc to return to Editor        " },

    { "                      ASCII Box Character Codes                    ",
      "ͻ",
      "   218196Ŀ191     201205ͻ187   ",
      "              194                           203              ",
      "                                                           ",
      "   195Ĵ180     204͹185   ",
      "              197                           206              ",
      "     179                                             186     ",
      "              193                           202              ",
      "   192217     200ͼ188   ",
      "   213205͸184     214196ķ183   ",
      "              209                           210              ",
      "                                                           ",
      "   198͵181     199Ķ182   ",
      "              216                           215              ",
      "     179                                             186     ",
      "              207                           208              ",
      "   212;190     211Ľ189   ",
      "ͼ",
      "         Space bar for next screen, Esc to return to Editor        " },

    { "                      ANSI Control Codes                           ",
      "ͻ",
      "                                  ESC[n;n;...nm SET ATTRIBUTES   ",
      "   ESC[y,xH   cursor y,x                                         ",
      "   ESC[nA     cursor up n        0 none   4 underline            ",
      "   ESC[nB     cursor down n      1 bold   5 blink   8 invisible  ",
      "   ESC[nC     cursor right n     2 dim    7 reverse              ",
      "   ESC[nD     cursor left n                                      ",
      "   ESC[s      save cursor                    FGnd    BGnd        ",
      "   ESC[u      restore cursor       black      30      40         ",
      "   ESC[2J     del display          red        31      41         ",
      "   ESC[K      del to EOLN          green      32      42         ",
      "   ESC[nL     ins n lines          yellow     33      43         ",
      "   ESC[nM     del n lines          blue       34      44         ",
      "   ESC[n@     ins n blanks         magenta    35      45         ",
      "   ESC[nP     del n chars          cyan       36      46         ",
      "                                   white      37      47         ",
      "                                                                 ",
      "ͼ",
      "         Space bar for next screen, Esc to return to Editor        " }
};

void    AsciiScreen() {

    int     asc_len, asc_size = 20;
    int     i, j, k = 0;
    int     ch;

    attr = bordcolor << 8;
    asc_len = strlen(ascii[0][0]);
    ux = (defnocols - asc_len) / 2 + 1;
    uy = (defnorows - asc_size) / 2 + 2;

    gotoXY(1, 1);

    do {
        for (i = 0; i < asc_size; i++) {
            for (j = 0; j < asc_len; j++)
                vrow[j] = attr | ascii[k][i][j] & 0xff;
            __vram(__vptr(ux, uy + i), (int far*)vrow, asc_len);
        }

        while ( !keypressed() ) donothing();

        if ( abortcmd ) break;
        else if ((ch = getinput()) == '\0') ch = getinput();
        else if (ch == ' ')  k = (k + 1) % 4;

    } while ( TRUE );
}

static  pchar help[][20] = {
 {" Help Screen One ͻ",
  "                                                                        ",
  "  CURSOR MOVEMENT COMMANDS           WINDOW SCROLL COMMANDS             ",
  "  ^E/X/S/D   up/dn/lf/rt a char      Up/Dn+scrlLck  scroll up/dn 1 line ",
  "  ^A/F       lf/rt a word            Lf/Rt+scrlLck  scrl lf/rt 1 column ",
  "  ^Up/Dn     up/dn a word            ^Lf/Rt+scrlLck scroll 1/2 screen   ",
  "  Alt-G      goto abs/rel linenum    PgUp/Dn     scroll up/dn 1 screen  ",
  "  Alt-Lf/Rt  1/2 to beg/end line     ^PgUp/Dn    line to top/bttm scrn  ",
  "  Home/End   begin/end of line       Alt-PgUp/Dn line 1/2 to top/bottom ",
  "  ^Home/End  top/bttm of screen                                         ",
  "  Alt-Hm/End 1/2 to top/bttm scrn    BLOCKED COMMANDS                   ",
  "  Alt-Up/Dn  1/2 to top/bttm scrn    ^KB,F7      mark blockbegin        ",
  "                                     ^KK,F8      mark blockend          ",
  "  WINDOW COMMANDS                    ^KH         unmark block           ",
  "  ^OO     toggle window creat/del    ^KY         delete marked block    ",
  "  Alt-S    switch active window      Alt-K       undel last deltd blk   ",
  "  F1..F4   switch phantom window     ^KC         copy block aft cursor  ",
  "  ^OUp/Dn   adjust window size       ^KV         move block aft cursor  ",
  "                                                                        ",
  " <Space Bar> = next screen, <Esc> = Abort ͼ"},

 {" Help Screen Two ͻ",
  "                                                                        ",
  "  DELETE and UNDELETE COMMANDS        FILE COMMANDS                     ",
  "  ^H/BS    delete left character      ^KR,F6 read a file into window    ",
  "  ^G/del   delete current character   ^KW    save file to new file name ",
  "  ^T         delete right word        ^KS,F9 save file to current fname ",
  "  ^BS        delete left word         ^KE    rename the current stream  ",
  "  ^Y/^del  delete current line                                          ",
  "  ^Tab/^QT delete to end of line      MISCELLANEOUS COMMANDS            ",
  "  ^QL      undo current line change   Lf/Rt+Shift  change case char     ",
  "  ^QY,F5   delete the whole window    Up/Dn+Shift  uppr/lwr case line   ",
  "  ^Ins     insert deleted line        ^OI          toggle autoindent    ",
  "                                      ^OE/D        entab/detab file     ",
  "  FIND and/or REPLACE COMMANDS        ^OT          set tab size         ",
  "  ^QF or F11  find                    Ins          toggle Ins/Ovr mode  ",
  "  ^QA or F12  find & replace          BackTab      go back one tabstop  ",
  "  ^L      find or find&replace again  ^U/Esc    cancel current command  ",
  " (In marked block find&rep is global) ^KA       macro redefinition      ",
  "                                                                        ",
  " <Space Bar> = next screen, <Esc> = Abort ͼ"},

 {" Help Screen Three ͻ",
  "                                                                        ",
  "                                                                        ",
  "  MISCELLANEOUS COMMANDS (contd)      IF CURSOR IN MARKED BLOCK:        ",
  "  Alt-Z     shell to Dos              ^P          caches marked block   ",
  "  ^KX,F10   exit Editor               ^del/del    deletes block         ",
  "  Shf Alt-X exit keep scrn at cursor  Lf/Rt       shifts block lf/rt    ",
  "  Alt-X     exit and clear screen                                       ",
  "  Alt-A     pop  ASCII code screens   IF CURSOR IN CACHE MESSAGE LINE:  ",
  "  Alt-C     pop C precedence screen   ^O   uncaches the cached block    ",
  "  Alt-L     load macro file           O    uncaches partially from top  ",
  "  Alt-V     pop Version screen        o    uncaches partially from end  ",
  "  ^n        insrt blnk line aft line                                    ",
  "  ^N        insrt blnk line bef line  IF A MARKED BLOCK EXIST:          ",
  "  Alt-Ins   duplicate a line          ^KW  writes block to new filename ",
  "  ^P        leadin for ctrl chars     ^QA  global find&replace in block ",
  "                                                                        ",
  "                                                                        ",
  "                                                                        ",
  " <Space Bar> = next screen, <Esc> = Abort ͼ"}
};

void    HelpScreen() {

    int     hlp_len, hlp_size = 20;
    int     i, j, k = 0;
    int     ch;

    attr = bordcolor << 8;
    hlp_len = strlen(help[0][0]);
    ux = (defnocols - hlp_len) / 2 + 1;
    uy = (defnorows - hlp_size) / 2 + 2;

    gotoXY(1, 1);

    do {
        for (i = 0; i < hlp_size; i++) {
            for (j = 0; j < hlp_len; j++)
                vrow[j] = attr | help[k][i][j] & 0xff;
            __vram(__vptr(ux, uy + i), (int far*)vrow, hlp_len);
        }

        while ( !keypressed() ) donothing();

        if ( abortcmd ) break;
        else if ((ch = getinput()) == '\0') ch = getinput();
        else if (ch == ' ')  k = (k + 1) % 3;

    } while ( TRUE );
}