/*
 *       ͻ
 *              Chi Programmer's Editor, Borland C++ 3.1       
 *                     
 *           Copyright (C) 1990,1991,1993                      
 *           Author: Fook H. Eng, 201 West Hilliard Avenue     
 *                   Monterey Park, CA 91754, 818 572-9220     
 *                                                             
 *       ͼ
 */
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <mem.h>
#include    <dos.h>
#include    <conio.h>
#include    <ctype.h>
#include    "vartypes.h"
#include    "keys.h"
#include    "utils.h"
#include    "screen.h"
#include    "memory.h"

static  int  keyready(void);
static  void stashkey(void);

void    write_vscrn(pchar buf, int row, int color)
{
    /*  writes characters to the virtual screen with attribute  */
    /*  designated. the hardware screen is not affected.        */

    int     i, attr = color << 8;

    for (i = 0; i < defnocols; i++)
        vscreen[row-1][i] = attr | buf[i] & 0xff;
}

void    write_scrln(register int row)
{
    /*  copies characters from the 'row'th row of the virtual    */
    /*  screen onto the corresponding row on the hardware screen */

        __vram(__vptr(1,row), (int far *) vscreen[row-1], defnocols);
}

void    update_row(pchar buf, int row, int color)
{
    write_vscrn(buf, row, color);
    write_scrln(row);
}

void    write_scrn()
{
    /*  copies the entire virtual screen data to hardware screen */

    register int row;

    for (row = 1; row <= defnorows; row++)
        __vram(__vptr(1,row), (int far *) vscreen[row-1], defnocols);
}

void    clear_scrln(int row) {

        __vram(__vptr(1, row), (int far *) blankrow, defnocols);
}

void    clear_remain(int cur_row) {

    register int row;

    for (row = cur_row; row <= defnorows; row++)
        __vram(__vptr(1,row), (int far *) blankrow, defnocols);
}


void    clear_scrn()
{
    register int row;

    for (row = 1; row <= defnorows; row++)
        __vram(__vptr(1,row), (int far *) blankrow, defnocols);
}

const     NORMAL  = 0x4700;     // normal white on red
const     BRIGHT  = 0x4f00;     // bright white on red

void  write_commands(pchar pbuf)
{
    char    buf[133];
    int     i;

    memset(buf, 0, 133);
    strcpy(buf, pbuf);
    for (i = 0; i < defnocols; i++)
        vscreen[0][i] = (isupper(buf[i]) ? BRIGHT : NORMAL) | buf[i] & 0xff;

    __vram(__vptr(1, 1), (int far *) vscreen[0], defnocols);
}


void  updwinsl(WinDesc * w)
{
    char whdr[133];
    char stat[64];
    char ai[3], ins[4];
    int  winnum;

    memset(whdr, ' ', 132);
    whdr[132] = '\0';

    winnum = (w == window1) ? 1 : 2;

    sprintf(stat, "Window:%d File:%s", winnum, w->filename);

    memcpy(whdr, stat, strlen(stat));


    strcpy (ai,  ((w->autoindent) ? "AI"  : "  "));
    strcpy (ins, ((w->insertflag) ? "INS" : "OVR"));

    sprintf(stat, "Line:%-3d  Col:%-3d  %s %s", w->clineno, w->colno, ai, ins);
    memcpy(whdr+defnocols-strlen(stat), stat, strlen(stat));

    update_row(whdr, w->firstlineno, bordcolor);
}

int     is_emptyline(pLineDesc p)
{
    int     i;

    for (i = p->bufflen - 1; i >= 0; i--)
        if (p->ptxt[i] != ' ') break;

    return (i < 0);         /* i < 0, then line is empty */
}

void    appcmdline(pchar title)
{
    memset(cmdline, ' ', MAXLINELENGTH);
    memcpy(cmdline, title, strlen(title));
    update_row(cmdline, 1, txtcolor);
}


void    updextraline()
{
    memmove(extra.txt, curwin->curline->ptxt, curwin->curline->bufflen);
    extra.dlen = curwin->curline->bufflen;
    extra.ptr  = curwin->curline;
}


void    restoreline()
{
    memmove(curwin->curline->ptxt, extra.txt, extra.dlen);
    memset(curwin->curline->ptxt + extra.dlen, ' ', curwin->curline->bufflen - extra.dlen);
}


/****
    Purpose: returns the column number of the first non-space character
    in the line descriptor.  Valid value for a non-space character is
    in the range 1 to bufflen.  If no non-space character exists, then
    the value 0 is returned.
                        ****/
int     firstchar(pLineDesc pld)
{
    int     firstch;

    firstch = 1;
    while (firstch <= pld->bufflen && pld->ptxt[firstch-1] == ' ')
        firstch++;

    return  firstch <= pld->bufflen ? firstch : 0;
}

/****
    Purpose: returns the column number of the last non-space character in
    the line descriptor.  If such a non-space character does not exist,
    the value returned is 0.
                          ****/
int     lastchar(pLineDesc pld)
{
    int     lastch;


    lastch = pld->bufflen;

    while (lastch > 0 && pld->ptxt[lastch-1] == ' ') lastch--;

    return  lastch;
}

int     getfcnkeychar() {

    while (!keypressed()) donothing();

    if (abortcmd) {
        return NOTAVAILABLE;
    }
    else if (getinput() == NULL)
        return (getinput());
    else
        return NOTAVAILABLE;
}

int     getctrlchar()
{
    int     ch;

    while (!keypressed()) donothing();

    if (abortcmd) {
        return NOTAVAILABLE;
    }
    else if ((ch = getinput()) >= 0x40 && ch <= 0x7a) return ch & 0x1f;
    else return ch;
}

int     getinput()
{
    int     ch;

    ch = circbuf[circout];
    circout = (circout + 1) % TYPEAHEAD;
    return  ch & 0x00ff;
}


int     getyesno(pchar ynstr)
{
    char    ch;

    appcmdline(ynstr);
    gotoXY(strlen(ynstr) + 1, 1);

    do {
        while (!keypressed()) {
            if (abortcmd) return FALSE;
        }
        ch = getinput();
    } while (strchr("yYnN", ch) == NULL);

    updcurflag = TRUE;

    return (strchr("yY", ch) != NULL);
}



void    askmacro(pchar cue, pchar mac) {

    int     cmdndx, tlndx;
    int     firstcol, byt, i;
    char    tline[MAXLINELENGTH];
    char    cline[MAXLINELENGTH];
    uchar   flags[MAXLINELENGTH];

    /***    tline[] is the macro string being constructed in askmac().
            flags[] tracks which char in tline[] is a control char.
            firstcol = col num below which cursor cannot descend.
            cmdndx   = index of next display char.  cursor column is cmdndx + 1.
            tlndx    = index of next entry to tline. ie. tline[tlndx++] = nextbyt.   ***/

    memset(cline, 0, MAXLINELENGTH);
    strcpy(cline, cue);
    strcpy(tline, mac);

    firstcol = strlen(cue) + 1;
    cmdndx = firstcol - 1;
    tlndx  = strlen(mac);
    for (i = 0; mac[i] != '\0'; i++) {
        if (mac[i] >= 0x20) {
            cline[cmdndx++] = mac[i];
            flags[i] = FALSE;
        }
        else if (mac[i] == 0x0d) {
            cline[cmdndx++] = '~';
            flags[i] = FALSE;
        }
        else {
            cline[cmdndx++] = '^';
            cline[cmdndx++] = mac[i] + 0x40;
            flags[i] = TRUE;
        }
    }

    appcmdline(cline);
    gotoXY(cmdndx+1, 1);

    while ( TRUE ) {

        while (!keypressed()) donothing();

        if (abortcmd) {
            appcmdline("");
            updcurflag = TRUE;
            return;
        }
        else if ( (byt = getinput()) == ctrlm ) break;

        if ( byt == ctrlh ) {
            if ( cmdndx != firstcol-1 ) {
                cline[--cmdndx] = ' ';
                tline[--tlndx]  = '\0';
                if ( flags[tlndx] ) {
                    cline[--cmdndx] = ' ';
                    flags[tlndx]    = FALSE;
                }
            }
        }
        else if ( byt > 0x00 && byt < 0x20 ) {
            cline[cmdndx++] = '^';
            cline[cmdndx++] = byt + 0x40;
            tline[tlndx]    = byt;
            flags[tlndx++]  = TRUE;
        }
        else {
            cline[cmdndx++] = byt;
            tline[tlndx] = byt == '~' ? 0x0d : byt;
            flags[tlndx++]  = FALSE;
        }

        update_row(cline, 1, txtcolor);
        gotoXY(cmdndx+1, 1);
    }

    appcmdline("");
    tline[tlndx] = '\0';     /* next character input is string terminator */
    strcpy(mac, tline);
    updcurflag = TRUE;
}


pchar askforstring(pchar askstring) {
    pchar pcmd;
    int     start, byt = 0;


    appcmdline(askstring);
    start = strlen(askstring) + 1;
    pcmd  =  cmdline + start;

    while (byt != ctrlm) {

        gotoXY(pcmd-cmdline+1, 1);

        while (!keypressed()) donothing();

        if (abortcmd) {
            appcmdline("");
            updcurflag = TRUE;
            return NULL;
        }

        if ((byt = getinput()) == ctrlh) {
            if (pcmd > cmdline + start) *--pcmd = ' ';
        }
        else if (byt != ctrlm) *pcmd++ = byt;

        update_row(cmdline, 1, txtcolor);
    }

    *pcmd = '\0';
    updcurflag = TRUE;
    return cmdline + start;
}

int     askfornum(pchar st)
{
    char    num[12];
    int     anum;

    strcpy(num, askforstring(st));

    anum = atoi(num);
    return anum < 0 ? 0 : anum;
}

static  REGS regs;

void    pokechr(int ch) {

    if (ch == ctrlu || ch == ESC) {
        circout = circin;               /* flush the buffer */
        appcmdline("");
        updcurflag = TRUE;
        abortcmd = TRUE;
        circbuf[circin] = ESC;
        circin = (circin+1) % TYPEAHEAD;
    }
    else if ((circin+1) % TYPEAHEAD == circout)
        appcmdline("Type ahead buffer overflowed");
    else {
        circbuf[circin] = ch;
        circin = (circin+1) % TYPEAHEAD;
    }
}

static  int  keyready() {

    regs.x.ax = chkkey;
    int86 (KEYBD, &regs, &regs);
    return (regs.x.flags & 0x40) == 0;
}

static  void stashkey() {

    regs.x.ax = getkey;
    int86 (KEYBD, &regs, &regs);

    if (regs.h.al == 0xe0) regs.h.al = NULL;

    pokechr(regs.h.al);

    if (regs.h.al == NULL) {
        circbuf[circin] = regs.h.ah;
        circin = (circin + 1) % TYPEAHEAD;
    }
}

int  keypressed() {

    if (keyready()) stashkey();

    return  (circin != circout);
}

void donothing()     {   }

void gotoXY(int col, int row) {

    //  had to create my own because Borland's built-in gotoxy()
    //  won't honor a non-80x25 screen format.
    regs.x.ax = 0x0200;
    regs.h.bh = 0;
    regs.h.dh = row - 1;
    regs.h.dl = col - 1;
    int86 (VIDEO, &regs, &regs);
}

void beep()
{
    static  int     g = 784;
    static  int     d = 587;

    sound (g);  delay (70); nosound();
    sound (d);  delay (70); nosound();
    sound (g);  delay (70); nosound();
    sound (d);  delay (70); nosound();
}

void set_cursor_type(int insert) {

    regs.x.ax = 0x0100;
    regs.x.bx = 0x0000;

    if (colormode)
        regs.x.cx = insert ? 0x0507 : 0x0007;
    else
        regs.x.cx = insert ? 0x0A0C : 0x000C;

    int86 (VIDEO, &regs, &regs);
}

/***
    Purpose: to indent the current line by an amount to match the
    first character of the previous line.  This does not assure
    the two lines to have the same indentation, because if current
    line is already indented it will be indented once again.
                                                            ***/
void  indentline()
{
    int         firstch, lastch;
    pLineDesc cl = curwin->curline;


    if ((firstch = firstchar(cl->paft)) > 1) {
        lastch = lastchar(cl);

        if (sizeline(cl, lastch+firstch-1) && lastch > 0) {
            memmove(cl->ptxt+firstch-1, cl->ptxt, lastch);
            memset(cl->ptxt, ' ', firstch-1);
        }

        curwin->leftedge = 1;
        curwin->colno = firstch;
    }
}