#include    <dos.h>
#include    "mouse.h"

const   TRUE            = 1;
const   FALSE           = 0;
const   TYPEAHEAD       = 95;
const   MAXDELLINE      = 12;
const   MAXDELBLOCK     =  4;
const   MAXCACHEBLK     =  8;
const   MAXWINSTACK     =  6;
const   MAXLINELENGTH   = 1023;
const   NOTAVAILABLE    =  255;
const   VIDEO           = 0x10;
const   KEYBD           = 0x16;

typedef unsigned char   uchar;
typedef char *          pchar;
typedef char  VARSTRING[MAXLINELENGTH];

struct LineDesc;
typedef LineDesc * pLineDesc;

struct LineDesc {
    pLineDesc  pfwd;
    pLineDesc  paft;
    pchar      ptxt;
    int        inblock;
    int        bufflen;
};

struct CacheType {
    pLineDesc     phd;          /* points to head of cache */
    pLineDesc     ptl;          /* points to tail of cache */
    pLineDesc     qld;          /* points to display cache line */
};

struct BlockType {
    pLineDesc     phead;
    pLineDesc     ptail;
};

struct WinDesc {
    WinDesc *   pfwd;
    char        filename[64];
    int         insertflag;
    int         autoindent;
    int         firstlineno;    // the window status line
    int         lastlineno;     // the lastline in the window
    int         lineno;         // window relative line number of text
    int         colno;
    int         clineno;        // absolute line number of text
    pLineDesc   topline;
    pLineDesc   curline;
    int         leftedge;
};

typedef WinDesc *pWindesc;

struct EXTRA {
    pLineDesc  ptr;
    pchar      txt[MAXLINELENGTH];
    int        dlen;
};

#ifdef  MAINDEF
    #define STORAGE_TYPE
#else
    #define STORAGE_TYPE extern
#endif

STORAGE_TYPE    int         abortcmd;
STORAGE_TYPE    int      *  blankrow;
STORAGE_TYPE    int         bright, bordcolor, blockcolor;
STORAGE_TYPE    pLineDesc   blockfro,  blockto;
STORAGE_TYPE    CacheType   cache[MAXCACHEBLK];
STORAGE_TYPE    int         chkkey, getkey;
STORAGE_TYPE    char        circbuf[TYPEAHEAD];
STORAGE_TYPE    int         circin, circout;
STORAGE_TYPE    int         cmdcol;
STORAGE_TYPE    char        cmdline[MAXLINELENGTH];
STORAGE_TYPE    char        cmdline2[MAXLINELENGTH];
STORAGE_TYPE    int         colormode;
STORAGE_TYPE    WinDesc   * curwin;
STORAGE_TYPE    int         defnorows, defnocols;
STORAGE_TYPE    BlockType   delblklist[MAXDELBLOCK];
STORAGE_TYPE    EXTRA       extra;
STORAGE_TYPE    char        fnamestr[MAXLINELENGTH];
STORAGE_TYPE    int         igncase;
STORAGE_TYPE    int         logscrrows, logscrcols, logtopscr;
STORAGE_TYPE    pLineDesc   pdellnlist[MAXDELLINE];
STORAGE_TYPE    BlockType * pdelblk;
STORAGE_TYPE    int         physcrrows, physcrcols;
STORAGE_TYPE    LineDesc ** ppdelln;
STORAGE_TYPE    VARSTRING   macstr[8];     /* array[f5..f12] of varstring */
STORAGE_TYPE    int         replast;
STORAGE_TYPE    char        replacestr[MAXLINELENGTH];
STORAGE_TYPE    int         rundown;
STORAGE_TYPE    char        searchstr[MAXLINELENGTH];
STORAGE_TYPE    int         scanningfwd;
STORAGE_TYPE    int         tabsize;
STORAGE_TYPE    int         txtcolor;
STORAGE_TYPE    int         updcurflag;
STORAGE_TYPE    int         vrow[80];
STORAGE_TYPE    int      ** vscreen;
STORAGE_TYPE    int         wholeword;
STORAGE_TYPE    WinDesc   * winstack;
STORAGE_TYPE    WinDesc   * window1;
STORAGE_TYPE    WinDesc   * windxyz[4];          /* pointers to phantom windows */
STORAGE_TYPE    Mouse       mymouse;
STORAGE_TYPE    int         mouse_Exist;
/** internal Turbo C stuff - known only to Al Stevens C column readers **/
#ifdef __cplusplus
    extern "C" {
    void far * pascal __vptr(int x, int y);
    void pascal __vram(void far * dest, void far * src, int length);
    }
#else
    void far * pascal __vptr(int x, int y);
    void pascal __vram(void far * dest, void far * src, int length);
#endif
/**************  end of mysterious internal Turbo C stuff  **************/