/*
 *       ͻ
 *              Chi Programmer's Editor, Borland C++ 3.1       
 *                     
 *           Copyright (C) 1990,1991,1993                      
 *           Author: Fook H. Eng, 201 West Hilliard Avenue     
 *                   Monterey Park, CA 91754, 818 572-9220     
 *                                                             
 *       ͼ
 */
#include    <stdio.h>
#include    <string.h>
#include    <alloc.h>
#include    "vartypes.h"
#include    "windows.h"
#include    "screen.h"
#include    "memory.h"
#include    "utils.h"
#include    "keys.h"

static  void   entab_line(pLineDesc);
static  void   entab(void);
static  pchar  detab_line(pLineDesc);
static  void   detab(void);
static  void   settab(void);

void    switch_window()
{
    if (curwin != curwin->pfwd) {
        curwin = curwin->pfwd;
        set_cursor_type(curwin->insertflag);
        updcurflag = TRUE;
    }
    else {
        appcmdline("No second window to switch to..");
        beep();
    }
}

/*
 *  opens a second window.  this function is called only if there exist
 *  only one window.  ctrlo ctrlo will call either open_/close_ window.
 */
void    open_window()
{
    WinDesc  * q, * p = curwin;
    int        size = (defnorows - 1) / 2;


    if ((q = creat_window(p->lastlineno-size+1,size,"nofile",1,1)) == NULL) {
        appcmdline("No more memory to create window");
        return;
    }

    p->lastlineno -= size;

    while (p->lineno > p->lastlineno - p->firstlineno) {
        p->lineno--;
        p->clineno--;
        p->curline = p->curline->paft;
    }

    p->pfwd = q;
    q->pfwd = p;
    switch_window();
}

/*
 *  closes the second window.  this function is called only if the second
 *  window is opened.  ctrlo ctrlo will call either open_/close_ window.
 */
void    close_window()
{
    WinDesc  * p;

    if (strcmp(curwin->filename, "nofile") != 0) {
        sprintf(cmdline2, "remove window with %s? [y/n]", curwin->filename);
        if (!getyesno(cmdline2)) {
            appcmdline("");
            return;
        }
    }

    p = curwin;
    if (p == window1) {
        window1 = p->pfwd;
        window1->firstlineno = p->firstlineno;
    }
    else
        window1->lastlineno = p->lastlineno;

    curwin = window1;
    window1->pfwd = window1;
    realign();

    while (p->topline->paft != NULL) p->topline = p->topline->paft;
    do {
        p->curline = p->topline->pfwd;
        freetxtdes(p->topline);
        p->topline = p->curline;
    } while (p->topline != NULL);

    p->pfwd = winstack;
    winstack = p;
    set_cursor_type(curwin->insertflag);
    appcmdline("");
}

//
//  EXPAND mean expanding the lower window and shrinking the upper.
//
void    expand_window() {

    WinDesc  * w1 = window1;

    if (w1 == w1->pfwd)         //  if only one window, nothing to expand
        beep();
    else {
        if (w1->lastlineno - w1->firstlineno == 1) {
            beep();             //  if cannot expand further, beep.
            return;
        }
        w1->lastlineno--;
        w1->pfwd->firstlineno--;
        if (w1->lineno > w1->lastlineno - w1->firstlineno) {
            w1->lineno--;
            w1->clineno--;
            w1->curline = w1->curline->paft;
        }
        if (w1->pfwd->topline->paft != NULL) {
            w1->pfwd->topline = w1->pfwd->topline->paft;
            w1->pfwd->lineno++;
        }
    }
}


void    shrink_window() {

    WinDesc  * w1 = window1->pfwd;

    if (w1 == window1)
        beep();
    else {
        if (w1->lastlineno - w1->firstlineno == 1) {
            beep();
            return;
        }
        w1->firstlineno++;
        w1->pfwd->lastlineno++;
        if (w1->lineno > 1) {
            w1->lineno--;
            w1->topline = w1->topline->pfwd;
        }
        else if (w1->topline->pfwd != NULL) {
            w1->topline = w1->topline->pfwd;
            w1->curline = w1->curline->pfwd;
            w1->clineno++;
        }
    }
}


void    towindowXYZ(int fkey) {

    WinDesc * pw;

    pw     = curwin;
    curwin = windxyz[fkey - F1];
    windxyz[fkey - F1] = pw;

    if (pw == window1) window1 = curwin;

    if (pw->pfwd == pw)
        curwin->pfwd = curwin;
    else {
        curwin->pfwd = pw->pfwd;
        pw->pfwd->pfwd = curwin;
    }

    {
        WinDesc  * cw = curwin;

        cw->firstlineno = pw->firstlineno;
        cw->lastlineno = pw->lastlineno;
        if (cw->lineno > cw->lastlineno - cw->firstlineno)
            while (cw->lineno > cw->lastlineno - cw->firstlineno) {
                cw->curline = cw->curline->paft;
                cw->lineno--;
                cw->clineno--;
            }
        set_cursor_type(cw->insertflag);
    }
    updcurflag = TRUE;
}

/***
    these are some of the things that may cause the current line either
    not to be within the current window or that if in the current window
    frame, the associated line number may be incorrect.
        phantom window switching, window resizing, block deletion.
    in any event, things must be set aright via realign().        ***/

void    realign()
{
    WinDesc  * pw = window1;
    pLineDesc pl;

    do {
        pw->lineno = 1;

        for (pl = pw->topline; pl != pw->curline; pl = pl->pfwd)
            if (pw->lineno < pw->lastlineno - pw->firstlineno) pw->lineno++;
            else pw->topline = pw->topline->pfwd;

    } while ((pw = pw->pfwd) != window1);
}

static  void  entab_line(pLineDesc pl)
{
    char    tline[MAXLINELENGTH];
    int     col, jcol, ncol;
    int     lastch;

    if ((lastch = lastchar(pl)) == 0) return;

    jcol = col = 1;

    do {
        ncol = col;
        while (pl->ptxt[ncol-1] == ' ' && ncol <= lastch) {
            ncol++;
            if (ncol % tabsize == 1) {
                tline[jcol-1] = TAB;
                jcol++;
                col = ncol;
            }
        }

        while (col < ncol) {
            tline[jcol-1] = ' ';
            jcol++;
            col++;
        }

        tline[jcol-1] = pl->ptxt[col-1];
        jcol++;
        col++;
    } while (col <= lastch);

    memmove(pl->ptxt, tline, jcol-1);
    memset(pl->ptxt+jcol-1, ' ', pl->bufflen-jcol+1);

}

static  void    entab()
{
    pLineDesc pline = curwin->curline;

    appcmdline("Converting spaces to tabs.. ");

    while (pline->paft != NULL) pline = pline->paft;

    while (pline != NULL) {
        entab_line(pline);
        pline = pline->pfwd;
    }

    appcmdline("");
}


static  pchar detab_line(pLineDesc pl) {

    int     i, j, lenbuf;
    static  char    tbuf[MAXLINELENGTH];

    memset(tbuf, ' ', MAXLINELENGTH);

    lenbuf = lastchar(pl);

    i = j = 1;
    if (lenbuf >= 1) {
        do {
            while (pl->ptxt[i-1] != TAB && i <= lenbuf) {
                tbuf[j-1] = pl->ptxt[i-1];
                i++;
                j++;
            }

            if (i <= lenbuf) {        /* a tab encountered */
                i++, j++;
                while (j % tabsize != 1) j++;
            }

        } while (i <= lenbuf);
    }
    tbuf[j-1] = '\0';
    return tbuf;
}

static  void    detab() {

    pLineDesc  p;
    pchar      tline;
    int        required;

    appcmdline("Converting tabs starting from current line .. Please wait");
    p = curwin->curline;

    while (p != NULL) {
        tline = detab_line(p);
        required = strlen(tline);
        if (!sizeline(p, required)) {
            appcmdline("File too large to detab any further");
            return;
        }
        memmove(p->ptxt, tline, required);
        p = p->pfwd;
    }

    appcmdline("");
}

static  void    settab()
{
    int     size;

    size = askfornum("Enter tab size");

    if (size > 1 && size < defnocols / 2) {
        tabsize = size;
        sprintf(cmdline2, "Tab size redefined to %d", size);
        appcmdline(cmdline2);
    }
}

void    edit_o(void)
{
    int       ch;
    pchar     tline;
    WinDesc * cw = curwin;
    char        cmdstr[] =
" tOggle_new_window  UP/DN_resize_wind  Entab  Detab  setTab  toggleIndent   ESC ";

    write_commands(cmdstr);
    do {
        while (!keypressed()) donothing();
        ch = getctrlchar();
        if (ch == NULL) {
            switch (ch = getinput()) {
                case UP:
                    expand_window();
                    gotoXY(cw->colno-cw->leftedge+1, cw->firstlineno+cw->lineno);
                    break;
                case DOWN:
                    shrink_window();
                    gotoXY(cw->colno-cw->leftedge+1, cw->firstlineno+cw->lineno);
                    break;
                default: break;
            }
        }
        refresh_screen();
    } while (ch == UP || ch == DOWN);

    appcmdline("");

    switch (ch) {
        case ctrld: detab();        break;

        case ctrle: entab();        break;

        case ctrli: curwin->autoindent = !curwin->autoindent;   break;

        case ctrlo:
            curwin->pfwd == curwin ? open_window() : close_window();
            break;

        case ctrlt: settab();       break;

        default: break;
    }
}